module CorrelationId
  module Middleware
    class Rack
      def initialize(app)
        @app = app
      end

      def call(env)
        CorrelationId.uuid = header_from_env(env)

        status, headers, body = @app.call(env)

        headers = headers.merge(HEADER_KEY => CorrelationId.uuid)
        [status, headers, body]
      end

      private

      def header_from_env(env)
        env["HTTP_#{HEADER_KEY.upcase.tr('-', '_')}"]
      end
    end
  end
end
